<script src="@#file#(bresenham.js)" type="text/javascript"></script>

<p>Na prethodnoj stranici u okviru jednog od danih primjera mogli smo uočiti da algoritam ne daje dobar prikaz ako je pravac pod kutem između 0° i -45°: rezultat je vodoravna linija jer je koeficijent smjera negativan pa pogreška nikada ne postane nula što za posljedicu ima da se y-koordinata nikada ne mijenja. Prikladan algoritam za taj bi slučaj bio:</p>

<pre>
void drawLine(int xs, int ys, int xe, int ye) {
  int x, yc;
  double a, yf;
  a = (ye−ys)/(double)(xe−xs);
  yc=ys; yf = 0.5;
  for(x=xs; x&lt;=xe; x++) {
    osvijetli_pixel(x, yc);
    yf = yf+a;
    if(yf&lt;=0.0) {
      yf=yf+1.0;
      yc=yc-1;
    }
  }
}
</pre>

<p>Ove obje inačice mogu se ujediniti u jednu na sljedeći način. metodu smo nazvali <code>drawLineX</code> jer petlja ide po osi x, a vrijednosti računa po osi y.</p>

<pre>
void drawLineX(int xs, int ys, int xe, int ye) {
  int x, yc;
  double a, yf;
  double dy = ye−ys;
  a = abs(dy)/(double)(xe−xs);
  int korekcija = dy&lt;0 ? -1 : 1;
  yc=ys; yf = -0.5;
  for(x=xs; x&lt;=xe; x++) {
    osvijetli_pixel(x, yc);
    yf = yf+a;
    if(yf&gt;=0.0) {
      yf=yf-1.0;
      yc=yc+korekcija;
    }
  }
}
</pre>

<p>Ovaj će postupak dobro crtati linije za kuteve od -45° do +45°. Isprobajte!</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas3" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var lineData3 = {x0: 1, y0: 1, x1: 17, y1: 8};
    var brcanvas3 = new RasterDisplay("myCanvas3", 20, 20);
    var alg3 = new BresenhamAlgorithm4(lineData3, brcanvas3);
    brcanvas3.idealLineData = lineData3;
    brcanvas3.paint();
  </script>
  drawLine(<input type="text" id="line3_x0" value="1" size="2">, <input type="text" id="line3_y0" value="1" size="2">, <input type="text" id="line3_x1" value="17" size="2">, <input type="text" id="line3_y1" value="8" size="2">)
  <button onclick="if(parseLineData('line3',lineData3)) {alg3.reset(); document.getElementById('alg3btn').disabled=false;}">Postavi</button><br>
  <button onclick="alg3.reset(); document.getElementById('alg3btn').disabled=false;">Reset</button>
  <button id="alg3btn" onclick="alg3.next(); if(!alg3.hasNext()) this.disabled=true;">Korak</button>
  <input id="alg3ch1" type="checkbox" onclick="brcanvas3.showIdealLine = document.getElementById('alg3ch1').checked ? true : false; brcanvas3.paint();"> Prikaz idealne linije

  <p>Isprobajte nacrtati sljedeće linije ovim algoritmom:</p>
  <ol>
    <li>drawLine(1,1,17,8): kut je između 0° i 45°</li>
    <li>drawLine(1,8,17,1): kut je između -45° i 0°</li>
    <li>drawLine(1,1,8,17): kut je između 45° i 90°</li>
    <li>drawLine(8,17,1,1): x-koordinata se smanjuje</li>
  </ol>

<p>Na sličan način, u skladu s prethodnom raspravom, možemo dobiti algoritam koji dobro crta linije koje su prema y-osi pod kutem od plus-minus 45°. Metodu ćemo nazvati <code>drawLineY</code> jer petlja ide po osi y, a vrijednosti računa po osi x.</p>

<pre>
void drawLineY(int xs, int ys, int xe, int ye) {
  int y, xc;
  double a, xf;
  double dx = xe−xs;
  a = abs(dx)/(double)(ye−ys);
  int korekcija = dy&lt;0 ? -1 : 1;
  xc=xs; xf = -0.5;

  for(y=ys; y&lt;=ye; y++) {
    osvijetli_pixel(xc, y);
    xf = xf+a;

    if(xf&gt;=0.0) {
      xf=xf-1.0;
      xc=xc+korekcija;
    }
  }
}
</pre>

<p>Isprobajte algoritam!</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas5" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var lineData5 = {x0: 1, y0: 1, x1: 17, y1: 8};
    var brcanvas5 = new RasterDisplay("myCanvas5", 20, 20);
    var alg5 = new BresenhamAlgorithm5(lineData5, brcanvas5);
    brcanvas5.idealLineData = lineData5;
    brcanvas5.paint();
  </script>
  drawLine(<input type="text" id="line5_x0" value="1" size="2">, <input type="text" id="line5_y0" value="1" size="2">, <input type="text" id="line5_x1" value="17" size="2">, <input type="text" id="line5_y1" value="8" size="2">)
  <button onclick="if(parseLineData('line5',lineData5)) {alg5.reset(); document.getElementById('alg5btn').disabled=false;}">Postavi</button><br>
  <button onclick="alg5.reset(); document.getElementById('alg5btn').disabled=false;">Reset</button>
  <button id="alg5btn" onclick="alg5.next(); if(!alg5.hasNext()) this.disabled=true;">Korak</button>
  <input id="alg5ch1" type="checkbox" onclick="brcanvas5.showIdealLine = document.getElementById('alg5ch1').checked ? true : false; brcanvas5.paint();"> Prikaz idealne linije

  <p>Isprobajte nacrtati sljedeće linije ovim algoritmom:</p>
  <ol>
    <li>drawLine(1,1,8,17): kut prema y-osi je između 0° i 45°</li>
    <li>drawLine(8,1,1,17): kut prema y-osi je između -45° i 0°</li>
    <li>drawLine(1,1,17,8): kut prema y-osi je između 45° i 90°</li>
    <li>drawLine(1,17,8,1): y-koordinata se smanjuje</li>
  </ol>

